SystemOrganization addCategory: #'Xenon-Tests'!
SystemOrganization addCategory: #'Xenon-Tests-Scenarios'!

TestCase subclass: #XeAbstractTest
	instanceVariableNames: 'cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 5/12/2012 22:55'!
assertTranslationOf: aClass 
	" assert expected equals the translation of aClass"
	| expectedString actualString |
	cg addClass: aClass.
	actualString := cg codeString.
	expectedString := aClass expected contents.
	self assert: expectedString = actualString description: 'XeScenarioBrowser browse: ', aClass asString.
	! !

!XeAbstractTest methodsFor: 'running' stamp: 'BernardoContreras 4/11/2012 02:23'!
setUp
	cg := XeCodeGenerator new! !

XeAbstractTest subclass: #XeTranslateFunctionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest commentStamp: 'BernardoContreras 4/5/2012 15:12' prior: 0!
To test the translation of functions
!

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/12/2012 22:49'!
testTranslateFunctionCallAnotherFunction
	self assertTranslationOf: XeFunctionCallAnotherFunctionScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:23'!
testTranslateFunctionCallAnotherFunctionWithTwoArguments
	self assertTranslationOf: XeFunctionCallAnotherFunctionWithTwoArgumentsScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:25'!
testTranslateFunctionThatReturnsZero
	self assertTranslationOf: XeFunctionThatReturnsZeroScenario! !

!XeTranslateFunctionTest methodsFor: 'testing errors' stamp: 'BernardoContreras 4/15/2012 01:30'!
testTranslateFunctionWhenItHasManyReturnTypes
	self should: [ cg addClass: XeFunctionThatHasManyReturnTypeScenario ] raise: XeTooManyReturnTypesError! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:27'!
testTranslateFunctionWhenReturnTypeIsDefault
	self assertTranslationOf: XeFunctionWithDefaultReturnTypeScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:29'!
testTranslateFunctionWhenReturnTypeIsInteger
	self assertTranslationOf: XeFunctionWhenReturnTypeIsIntegerScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:34'!
testTranslateFunctionWithOneArgument
	self assertTranslationOf: XeFunctionWithOneArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:41'!
testTranslateFunctionWithOneIntegerArgument
	self assertTranslationOf: XeFunctionWithOneIntegerArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:43'!
testTranslateFunctionWithTwoArguments
	self assertTranslationOf: XeFunctionWithTwoArgumentsScenario! !

XeAbstractTest subclass: #XeTranslateIfStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateIfStatementTest commentStamp: 'BernardoContreras 4/11/2012 02:33' prior: 0!
To test the translation of the if statement!

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/16/2012 22:47'!
testTranslateIfFalseAsArgumentInReturnStatement
	self assertTranslationOf: XeIfFalseAsArgumentInReturnScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/28/2012 18:18'!
testTranslateIfFalseIfTrueStatement
	self assertTranslationOf: XeIfFalseIfTrueScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/22/2012 04:31'!
testTranslateIfFalseStatement
	self assertTranslationOf: XeIfFalseScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/24/2012 23:44'!
testTranslateIfTrueIfFalseStatement
	self assertTranslationOf: XeIfTrueIfFalseScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/12/2012 20:48'!
testTranslateIfTrueStatement
	self assertTranslationOf: XeIfTrueScenario! !

XeAbstractTest subclass: #XeTranslateWhileStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/12/2012 18:10'!
testTranslateDoWhileFalseStatement
	self assertTranslationOf: XeDoWhileFalseScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:19'!
testTranslateDoWhileTrueStatement
	self assertTranslationOf: XeDoWhileTrueScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/11/2012 22:48'!
testTranslateWhileFalseDoStatement
	self assertTranslationOf: XeWhileFalseDoScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/12/2012 01:51'!
testTranslateWhileFalseStatement
	self assertTranslationOf: XeWhileFalseScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/1/2012 23:45'!
testTranslateWhileTrueDoStatement
	self assertTranslationOf: XeWhileTrueDoScenario! !

!XeTranslateWhileStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 5/1/2012 23:45'!
testTranslateWhileTrueStatement
	self assertTranslationOf: XeWhileTrueScenario! !

TestCase subclass: #XeCLiteralValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeCLiteralValueTest commentStamp: 'BernardoContreras 4/11/2012 19:47' prior: 0!
To test the translation of objects to a C literal value.
!

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/22/2012 04:06'!
testCharTranslateToQuotedChar
	| expected actual |
	expected := '''' , 'e' , ''''.
	actual := $e asCLiteralValue.
	self assert: expected equals: actual! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 19:49'!
testFalseTranslateToZero
	self assert: '0' equals: false asCLiteralValue! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 20:18'!
testNilTranslateToNull
	self assert: 'null' equals: nil asCLiteralValue! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 00:17'!
testStringTranslateToQuotedString
	| expected actual |
	expected := '"' , 'aString' , '"'.
	actual := 'aString' asCLiteralValue.
	self assert: expected equals: actual! !

!XeCLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 19:51'!
testTrueTranslateToZero
	self assert: '1' equals: true asCLiteralValue! !

TestCase subclass: #XeTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTypeTest methodsFor: 'testing' stamp: 'BernardoContreras 4/22/2012 01:50'!
testEquality
	self assert: #void asXeType = #void asXeType! !

Object subclass: #XeDiffBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeDiffBuilder commentStamp: 'BernardoContreras 4/11/2012 01:11' prior: 0!
To show you the diff between what it is expected and the actual translation.!

!XeDiffBuilder class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/11/2012 01:19'!
openFor: aClassScenario
 	| cg expectedString actualString diff |
	cg := XeCodeGenerator new.
	cg addClass: aClassScenario.
	actualString := cg codeString.
	expectedString := aClassScenario expected contents.
	diff := (StringHolder new textContents: (TextDiffBuilder buildDisplayPatchFrom: actualString to: expectedString)).
	expectedString = actualString 
		ifTrue: [	diff openLabel: aClassScenario asString, ' works!!'. ] 
		ifFalse: [ diff openLabel: aClassScenario asString, ' expected in green. actual in red'. ]			
	
! !

Object subclass: #XeDoWhileFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeDoWhileFalseScenario commentStamp: 'BernardoContreras 5/12/2012 20:22' prior: 0!
[ stmt. ] doWhileFalse: [ stmt2. lastStmt. ]
==>
do {
	stmt;
		{	
		stmt2;
		if (lastStmt) break;
		}
	} while (1);
 
!

!XeDoWhileFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/12/2012 22:56'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'do {'.
	expected indentation: 2.
	expected << '2;'.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (0) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '} while (1);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeDoWhileFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:26'!
foo
	<returnType: #void>
	[ 2 ] doWhileFalse: [ false ]
 ! !

Object subclass: #XeDoWhileTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeDoWhileTrueScenario commentStamp: 'BernardoContreras 5/12/2012 20:22' prior: 0!
[ stmt. ] doWhileTrue: [ stmt2. lastStmt. ]
==>
do {
	stmt;
		{	
		stmt2;
		if (!!(lastStmt)) break;
		}
	} while (1);
 
!

!XeDoWhileTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/12/2012 20:29'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'do {'.
	expected indentation: 2.
	expected << '2;'.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (!!(1)) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '} while (1);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeDoWhileTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:26'!
foo
	<returnType: #void>
	[ 2 ] doWhileTrue: [ true ]
 ! !

Object subclass: #XeFunctionCallAnotherFunctionScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionCallAnotherFunctionScenario commentStamp: 'BernardoContreras 4/8/2012 00:40' prior: 0!
A function call another function.
!

!XeFunctionCallAnotherFunctionScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:09'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int bar(int y);'.
	expected << 'int foo(int x);'.
	expected << 'int bar(int y){'.
	expected indentation: 1.
	expected << 'return y + 1;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(int x){'.
	expected indentation: 1.
	expected << 'return bar(x);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:42'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:41'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x! !

Object subclass: #XeFunctionCallAnotherFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:08'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int barand(int z, int y);'.
	expected << 'int foo(int x);'.
	expected << 'int barand(int z, int y){'.
	expected indentation: 1.
	expected << 'return y + z;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(int x){'.
	expected indentation: 1.
	expected << 'return barand(x, 5);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:18'!
bar: z and: y
	<returnType: #int>
	<var: #z type: #int>
	<var: #y type: #int>
	^ y + z! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:19'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x and: 5! !

Object subclass: #XeFunctionThatHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionThatHasManyReturnTypeScenario commentStamp: 'BernardoContreras 4/7/2012 20:19' prior: 0!
A function that has many return types.
!

!XeFunctionThatHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeFunctionThatReturnsZeroScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionThatReturnsZeroScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function that returns zero
!

!XeFunctionThatReturnsZeroScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:06'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return 0;'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionThatReturnsZeroScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 18:49'!
foo
	<returnType: #int>
	^ 0
		
! !

Object subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWhenReturnTypeIsIntegerScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function when return type is integer.
!

!XeFunctionWhenReturnTypeIsIntegerScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:28'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected << '}'.
	^ expected! !

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeFunctionWithDefaultReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithDefaultReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:19' prior: 0!
A function with a default return type.
!

!XeFunctionWithDefaultReturnTypeScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:27'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'sqInt foo(void);'.
	expected << 'sqInt foo(void){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithDefaultReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithOneArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 15:24' prior: 0!
A function with one argument.
!

!XeFunctionWithOneArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 00:16'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(sqInt x);'.
	expected << 'int foo(sqInt x){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

Object subclass: #XeFunctionWithOneIntegerArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithOneIntegerArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 17:06' prior: 0!
A function with one integer argument.
!

!XeFunctionWithOneIntegerArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:41'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(int x);'.
	expected << 'int foo(int x){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithOneIntegerArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 16:05'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	! !

Object subclass: #XeFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithTwoArgumentsScenario commentStamp: 'BernardoContreras 4/7/2012 20:20' prior: 0!
A function with two arguments.
!

!XeFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:47'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int fooand(sqInt x, sqInt y);'.
	expected << 'int fooand(sqInt x, sqInt y){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/13/2012 00:15'!
foo: x and: y
	<returnType: #int>
	! !

Object subclass: #XeIfFalseAsArgumentInReturnScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfFalseAsArgumentInReturnScenario commentStamp: 'BernardoContreras 5/16/2012 22:40' prior: 0!
condition ifFalse: [ stmts. lastStmt. ]
==>
 (!!(condition) ? lastStmt : 0)
!

!XeIfFalseAsArgumentInReturnScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/16/2012 22:46'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return (!!(0) ? 2 : 0);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfFalseAsArgumentInReturnScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/16/2012 22:45'!
foo
	<returnType: #int>
	^ false
		ifFalse: [ 2 ]! !

Object subclass: #XeIfFalseIfTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfFalseIfTrueScenario commentStamp: 'BernardoContreras 5/12/2012 00:58' prior: 0!
condition 
	ifFalse: [ FalseStmts. ]
	ifTrue: [ TrueStmts. ]
==>
if (condition){
	FalseStmts;
} else {
	TrueStmts;
}!

!XeIfFalseIfTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:46'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (!!(1)) {'.
	expected indentation: 2.
	expected << '21;'.
	expected << '} else {'.
	expected indentation: 2.
	expected << '22;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfFalseIfTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:21'!
foo
	<returnType: #void>
	true
		ifFalse: [ 21 ]
		ifTrue: [ 22 ]! !

Object subclass: #XeIfFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfFalseScenario commentStamp: 'BernardoContreras 5/12/2012 01:55' prior: 0!
condition ifFalse: [ stmts. ]
==>
if (!!(condition)){
	stmts;
}
!

!XeIfFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:44'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (!!(0)) {'.
	expected indentation: 2.
	expected << '0;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:21'!
foo
	<returnType: #void>
	false
		ifFalse: [ 0 ]! !

Object subclass: #XeIfTrueIfFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueIfFalseScenario commentStamp: 'BernardoContreras 5/12/2012 00:47' prior: 0!
condition 
	ifTrue: [ TrueStmts. ]
	ifFalse: [ FalseStmts. ]
==>
if (condition){
	TrueStmts;
} else {
	FalseStmts;
}
!

!XeIfTrueIfFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:50'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (1) {'.
	expected indentation: 2.
	expected << '21;'.
	expected << '} else {'.
	expected indentation: 2.
	expected << '22;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueIfFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:20'!
foo
	<returnType: #void>
	true
		ifTrue: [ 21 ]
		ifFalse: [ 22 ]! !

Object subclass: #XeIfTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueScenario commentStamp: 'BernardoContreras 5/12/2012 01:55' prior: 0!
condition ifTrue: [ stmts. ]
==>
if (condition){
	stmts;
}
!

!XeIfTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:43'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (1) {'.
	expected indentation: 2.
	expected << '0;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 15:18'!
foo
	<returnType: #void>
	true
		ifTrue: [ 0 ]! !

Object subclass: #XeWhileFalseDoScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileFalseDoScenario commentStamp: 'BernardoContreras 5/11/2012 22:49' prior: 0!
[ stmt.
  lastStmt ] whileFalse: [ stmt2. ]
==>
while (1){
	{	
		stmt;
		if (lastStmt) break;
	}
	stmt2;
}!

!XeWhileFalseDoScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (0) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '2;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileFalseDoScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:28'!
foo
	<returnType: #void>
	[ false ] whileFalse: [ 2 ]
 ! !

Object subclass: #XeWhileFalseScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileFalseScenario commentStamp: 'BernardoContreras 5/12/2012 01:37' prior: 0!
[ stmt.
  lastStmt ] whileFalse
==>
while (1){
	stmt;
	if (lastStmt) break;
}!

!XeWhileFalseScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 2.
	expected << 'if (1) break;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileFalseScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 01:49'!
foo
	<returnType: #void>
	[ true ] whileFalse! !

Object subclass: #XeWhileTrueDoScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileTrueDoScenario commentStamp: 'BernardoContreras 5/11/2012 22:43' prior: 0!
[ stmt.
  lastStmt ] whileTrue: [ stmt2. ]
==>
while (1){
	{	
		stmt;
		if (!!(lastStmt)) break;
	}
	stmt2;
}!

!XeWhileTrueDoScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 2.
	expected indentation: 3.
	expected << '{'.
	expected << 'if (!!(1)) break;'.
	expected << '}'.
	expected indentation: 2.
	expected << '2;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileTrueDoScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/12/2012 20:28'!
foo
	<returnType: #void>
	[ true ] whileTrue: [ 2 ]
 ! !

Object subclass: #XeWhileTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeWhileTrueScenario commentStamp: 'BernardoContreras 5/11/2012 22:44' prior: 0!
[ stmt.
  lastStmt ] whileTrue
==>
while (1){
	stmt;
	if (!!(lastStmt)) break;
}
!

!XeWhileTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 5/13/2012 04:51'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'while (1) {'.
	expected indentation: 2.
	expected << 'if (!!(1)) break;'.
	expected << '}'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeWhileTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 5/1/2012 23:44'!
foo
	<returnType: #void>
	[ true ] whileTrue! !
